
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-histType.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "HROOTCoreTObject.h"

#include "STDDeletable.h"

#include "HROOT-coreType.h"


#define TGRAPH2D_DECL_VIRT(Type) \
void Type##_SetN ( Type##_p p, int n );\
void Type##_SetPointXYZ ( Type##_p p, int i, double x, double y, double z );


#define TGRAPH2D_DECL_NONVIRT(Type) \
Type##_p Type##_newTGraph2D_ (  );\
Type##_p Type##_newTGraph2D ( int n, double* x, double* y, double* z );\
TAxis_p Type##_tGraph2D_GetXaxis ( Type##_p p );\
TAxis_p Type##_tGraph2D_GetYaxis ( Type##_p p );\
TAxis_p Type##_tGraph2D_GetZaxis ( Type##_p p );\
void Type##_tGraph2D_SetMaximum ( Type##_p p, double x );\
void Type##_tGraph2D_SetMinimum ( Type##_p p, double x );


#define TGRAPH2D_DECL_ACCESSOR(Type) \



#define TGRAPH2D_DEF_VIRT(Type) \
void Type##_SetN ( Type##_p p, int n ) {\
((TYPECASTMETHOD(Type, SetN, TGraph2D))(p))->Set(n);\
}\
\
void Type##_SetPointXYZ ( Type##_p p, int i, double x, double y, double z ) {\
((TYPECASTMETHOD(Type, SetPointXYZ, TGraph2D))(p))->SetPoint(i, x, y, z);\
}


#define TGRAPH2D_DEF_NONVIRT(Type) \
Type##_p Type##_newTGraph2D_ (  ) {\
Type* newp=new Type();return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}\
\
Type##_p Type##_newTGraph2D ( int n, double* x, double* y, double* z ) {\
Type* newp=new Type(n, x, y, z);return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}\
\
TAxis_p Type##_tGraph2D_GetXaxis ( Type##_p p ) {\
return from_nonconst_to_nonconst<TAxis_t, TAxis>((TAxis*)((TYPECASTMETHOD(Type, tGraph2D_GetXaxis, TGraph2D))(p))->GetXaxis());\
}\
\
TAxis_p Type##_tGraph2D_GetYaxis ( Type##_p p ) {\
return from_nonconst_to_nonconst<TAxis_t, TAxis>((TAxis*)((TYPECASTMETHOD(Type, tGraph2D_GetYaxis, TGraph2D))(p))->GetYaxis());\
}\
\
TAxis_p Type##_tGraph2D_GetZaxis ( Type##_p p ) {\
return from_nonconst_to_nonconst<TAxis_t, TAxis>((TAxis*)((TYPECASTMETHOD(Type, tGraph2D_GetZaxis, TGraph2D))(p))->GetZaxis());\
}\
\
void Type##_tGraph2D_SetMaximum ( Type##_p p, double x ) {\
((TYPECASTMETHOD(Type, tGraph2D_SetMaximum, TGraph2D))(p))->SetMaximum(x);\
}\
\
void Type##_tGraph2D_SetMinimum ( Type##_p p, double x ) {\
((TYPECASTMETHOD(Type, tGraph2D_SetMinimum, TGraph2D))(p))->SetMinimum(x);\
}


#define TGRAPH2D_DEF_ACCESSOR(Type) \



TNAMED_DECL_VIRT(TGraph2D)
TATTLINE_DECL_VIRT(TGraph2D)
TATTFILL_DECL_VIRT(TGraph2D)
TATTMARKER_DECL_VIRT(TGraph2D)
TOBJECT_DECL_VIRT(TGraph2D)
DELETABLE_DECL_VIRT(TGraph2D)
TGRAPH2D_DECL_VIRT(TGraph2D)
TGRAPH2D_DECL_NONVIRT(TGraph2D)
TGRAPH2D_DECL_ACCESSOR(TGraph2D)

#ifdef __cplusplus
}
#endif

